/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_LabelTypes;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_LabelTypes;


/**
 * This class represents LabelTypes - CID10022
 */
public class LabelTypes_CID10022 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new LabelTypes_CID10022 Template 
	 */
	public LabelTypes_CID10022()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumLabelTypes Object of EnumCM_LabelTypes represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_LabelTypes enumLabelTypes)
	{
		switch(enumLabelTypes)
		{
		case SERIES_NUMBER: this.strCodeValue =EnumCV_LabelTypes.SERIES_NUMBER_113607.getValue(); break;
		case ACQUISITION_NUMBER: this.strCodeValue =EnumCV_LabelTypes.ACQUISITION_NUMBER_113608.getValue(); break;
		case INSTANCE_NUMBER: this.strCodeValue =EnumCV_LabelTypes.INSTANCE_NUMBER_113609.getValue(); break;
		}
	}

	/**
	 * Sets the value for LabelTypes
	 * @param enumLabelTypes Object of EnumCM_LabelTypes.
	 */
	public void setLabelTypes(EnumCM_LabelTypes enumLabelTypes)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumLabelTypes.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumLabelTypes);
	}
}
